<template>
  <div v-if="isVisible">
    <v-card :loading="isLoadingCumplimientoPuntajePorNivel">
      <IdGrafico id="011" />
      <div class="gris">
        <h2 class="tituloBloque">
          Cumplimiento y puntaje a nivel
          <span
            v-if="
              globalFilters &&
                globalFilters.filters.nivel_geografico.descripcion
            "
            class="bold keep-spaces"
            >{{
              " " + globalFilters.filters.nivel_geografico.descripcion
            }}</span
          >
        </h2>
        <div class="divCumplimiento scrollY">
          <v-simple-table class="tblVue tblDistribucion">
            <template v-slot:default>
              <thead class="tblHead">
                <tr>
                  <th class="text-center">Puntos de contacto</th>
                  <th class="text-center">Puntos de contacto #</th>
                  <th class="text-center">Cumple #</th>
                  <th class="text-center">Cumple %</th>
                  <th class="text-center">Puntaje</th>
                </tr>
              </thead>
              <tbody class="tblBody">
                <template v-for="(itemCeco, indexItemCeco) in cecos">
                  <tr :key="indexItemCeco">
                    <td class="cantidad">
                      <a @click="zoomSearchCeco(itemCeco)" class="liga">
                        {{ itemCeco.id_ceco + " " + itemCeco.descripcion_ceco }}
                      </a>
                    </td>
                    <td class="cantidad">
                      {{ itemCeco.punto_contacto }}
                    </td>
                    <td class="cantidad">{{ itemCeco.cumple }}</td>
                    <td class="cantidad">
                      {{ itemCeco.porcentaje_cumplimiento }}%
                    </td>
                    <td class="cantidad">
                      <div
                        class="circle"
                        :style="{ backgroundColor: itemCeco.rango.detalle }"
                      ></div>
                      {{ itemCeco.puntaje }}
                    </td>
                  </tr>
                </template>
              </tbody>
            </template>
          </v-simple-table>
        </div>
      </div>
    </v-card>
  </div>
</template>
<style scoped>
a.liga {
  color: #000000 !important;
  text-decoration: underline;
  font-family: "AvenirNextLTPro-Medium";
  cursor: pointer;
}
.gris {
  width: 100%;
  margin: 0px auto;
  padding: 15px 15px;
  background-color: #faf9f9;
  -moz-box-shadow: 0 0px 1px rgb(226, 222, 222);
  -webkit-box-shadow: 0 0px 1px rgb(226, 222, 222);
  box-shadow: 0 0px 1px rgb(226, 222, 222);
  margin-bottom: 15px;
  text-align: justify;
  height: 100%;
}
.tituloBloque {
  font-size: 18px;
  color: #000;
  padding-bottom: 15px;
  font-family: "Avenir_Next_Regular", sans-serif;
}
.bold {
  font-family: "Avenir_Next_Bold", sans-serif;
}
</style>
<style scoped>
.tblVue {
  width: 100%;
  background-color: #fcfcfc !important;
}
.tblVue .tblHead tr th {
  padding: 5px 10px 6px 10px;
  color: #333333 !important;
  text-align: center;
  font-weight: 100;
  border-bottom: 1px solid #3e3d3d !important;
  font-size: 14px;
  font-family: "Avenir_Next_Bold";
  min-width: 87px;
}
.tblVue .v-data-table__wrapper {
  overflow-x: hidden !important;
}
.tblVue .tblBody tr td {
  padding: 7px 10px 7px 10px;
  color: #606664;
  font-size: 13px;
  text-align: center;
  border-bottom: 1px solid #bebebe !important;
}
.tblVue .tblBody tr:last-of-type td {
  border-bottom: none !important;
}
.theme--light.v-data-table tbody tr:hover {
  background: #eeeeee !important;
}
.tblVue tbody tr td.cantidad {
  width: 120px;
  margin: auto;
  text-align: center;
  color: #000;
}
.tblVue tbody tr td .circle {
  width: 15px;
  height: 15px;
  border-radius: 100%;
  display: inline-block;
  margin-right: 5px;
  background-color: gray;
}
.tblVue tbody tr td img {
  width: 65px;
}
.tblVue tr.total td {
  font-family: "Avenir_Next_Demi_Bold";
}
.divCumplimiento {
  width: 100%;
  margin: 0 auto;
  border: 1px solid #bfbfbf;
  padding-top: 10px;
}
.divCumplimiento .tblVue,
.divCumplimiento7s .tblVue {
  padding: 15px;
  box-sizing: border-box;
}
.puntajeAmarillo {
  background-color: #f3c75c;
}
.scrollY {
  overflow-y: scroll;
}
</style>
<script>
import axios from "axios";
import IdGrafico from "@/views/secure/sistema-informacion/dashboards/commons/IdGraficoLabel.vue";
export default {
  name: "Component-CumplimientoPuntajePorNivel",
  components: {
    IdGrafico
  },
  props: {
    methodsSemaforoParent: Object,
    globalFiltersParent: Object
  },
  data() {
    return {
      isVisible: true,
      isPersentValue: true,
      isLoadingCumplimientoPuntajePorNivel: true,
      methodsSemaforo: null,
      cecos: null,
      globalFilters: null,
      originalFilters: null,
      zoomSearchCeco: null
    };
  },
  methods: {
    listenSearchConsulta(globalFilters, originalFilters, zoomSearchCeco) {
      if (
        globalFilters.final_filters.nivel_geografico > 1 &&
        globalFilters.final_filters.id_negocio > 0
      ) {
        this.isVisible = true;
        this.globalFilters = globalFilters;
        this.originalFilters = originalFilters;
        this.zoomSearchCeco = zoomSearchCeco;
        this.getCumplimientoPuntajePorNivel();
      } else {
        this.isVisible = false;
      }
    },
    listenSemaforo(methodsSemaforo) {
      this.methodsSemaforo = methodsSemaforo;
    },
    getCumplimientoPuntajePorNivel() {
      this.isLoadingCumplimientoPuntajePorNivel = true;
      const self = this;
      const contentFiltros = {
        filtros: this.globalFilters.final_filters
      };
      axios
        .post(
          "franquicia/dashboard/secure/grafico/get/cumplimiento/puntaje/negocios/nivel",
          contentFiltros
        )
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                self.setCumplimientoPuntajePorNivel(data);
              }
            } else {
              self.setCumplimientoPuntajePorNivel([]);
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {
          self.isLoadingCumplimientoPuntajePorNivel = false;
        });
    },
    setCumplimientoPuntajePorNivel(cecos) {
      cecos.forEach((itemCeco) => {
        if (
          this.methodsSemaforo &&
          this.methodsSemaforo.getRangoByLimit(itemCeco.calificacion)
        ) {
          let rango = this.methodsSemaforo.getRangoByLimit(itemCeco.calificacion);
          itemCeco.rango = {
            detalle: rango.detalle
          };
        } else {
          itemCeco.rango = {
            detalle: ""
          };
        }
      });
      this.cecos = cecos;
    }
  },
  mounted() {
    this.$root.$on("searchconsulta", this.listenSearchConsulta);
    this.$root.$on("rangoloaded", this.listenSemaforo);
  },
  created() {
    this.methodsSemaforo = this.methodsSemaforoParent;
    this.globalFilters = this.globalFiltersParent;
    if (this.globalFilters) {
      this.getCumplimientoPuntajePorNivel();
    }
  }
};
</script>
